getf('transformations.sci');

fid=mopen('generatrices.txt','r');
a=mfscanf(16,fid,'%f %f');
R=a(:,1)';
Z=a(:,2)';

function [x,y,z]=vase(theta,nb)
x=R(nb).*cos(theta);
y=R(nb).*sin(theta);
z=Z(nb).*ones(theta);
endfunction;

//generation des facettes
theta=linspace(-%pi,%pi,20);
[xv,yv,zv]=eval3dp(vase,theta,1:16);
XYZ=[xv(:)';yv(:)';zv(:)'];

//dessin du vase
plot3d(xv,yv,zv,theta=44,alpha=66,leg="X@Y@Z",flag=[55 5 4],ebox=[-3 3 -3 3 -3 3]);

//translation + homothetie
XYZT=translation([1;3;-3],XYZ);
XYZH=homothetie([1;3;-3],1.5*[1 1 1],XYZT);

//retour a larepresentation par facettes
xx1=matrix(XYZH(1,:),4,-1);
yy1=matrix(XYZH(2,:),4,-1);
zz1=matrix(XYZH(3,:),4,-1);

//affichage
plot3d(xx1,yy1,zz1,theta=44,alpha=66,leg="X@Y@Z",flag=[55 5 4],ebox=[-3 3 -3 3 -3 3]);

//translation + rotation
XYZR=rotation([40;0;90],XYZT);

//retour a la representation par facette
xx2=matrix(XYZR(1,:),4,-1);
yy2=matrix(XYZR(2,:),4,-1);
zz2=matrix(XYZR(3,:),4,-1);

//affichage
plot3d(xx2,yy2,zz2,theta=44,alpha=66,leg="X@Y@Z",flag=[55 5 4],ebox=[-3 3 -3 3 -3 3]);